{   
    12-2018 started
    LSM9DS1 Gyro/Accel/Mag Driver + Balancing Math 
    
    GPS + Alti to be added as well    

    
}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

 'LSM9DS1 Sensitivity Settings
  AccelSens   = 8     '8g/sec max acceleration limit
  GyroSens    = 500   '500deg/sec max rotation limit
  Smoothing   = 25    'Number of samples to average for output smoothing

 'LSM9DS1 Pin Connections
  SCL_PIN     = 1
  SDIO_PIN    = 2
  CS_AG_PIN   = 3
  CS_M_PIN    = 4
  INT_AG_PIN  = 5
  INT_M_PIN   = 6



  
OBJ     

  ser       : "com.serial.terminal"       'PST
  time      : "time"                      'Time control for loop delays
  imu       : "sensor.imu.tri.lsm9ds1"    'LSM9DS1 Gyro Driver
  int       : "string.integer"            'Displays integers in PST
  fp        : "floatstring"               'Displays floating-point numbers in PST
  ff        : "fme"                       'Floating-point math
  
VAR

  long  stack[500]      'Give plenty of ram
  long  ARollDeg, APitchDeg, ax, ay, az, nty, PiCalc
  long  GRollDeg, GPitchDeg, gx, gy, gz 
  long  gxa, gya, gza, GRTrack, GPTrack, Timer 'Gyro calculations 

PUB Main                                                          

PiCalc := ff.FDiv(180.0, PI)   ' Pre-calculated value to reduce processing   
fp.SetPrecision(4)             ' Set Floating-point precision decimal places
  
 cognew(Balance(@ARollDeg, @APitchDeg, @GRollDeg, @GPitchDeg, @Timer), @stack[100])  'Start local IMU Balancing Math processes in new cog
                                                              
 
 waitcnt(clkfreq * 3 + cnt)  'Allow 3sec for PST to be opened                                                               
 Display                     'Start PST Output Display 

                      
                                                                   

PUB Display | Gscale, Ascale

 ser.Start (115_200)        ' Start Serial Terminal
 ser.Clear                  ' Clear Screen

Ascale := imu.getAccelScale  
Gscale := imu.getGyroScale  

  Repeat
    ser.Clear
    
    ser.Str (string("Accel Scale: "))
    ser.Str (int.DecPadded(Ascale,6))

    ser.Str (string(ser#NL, "Accel Roll:  "))        
    ser.str (fp.floattostring(ARollDeg))
    ser.Str (string(" deg    ")) 

    ser.Str (string(ser#NL, "Accel Pitch: "))
    ser.str (fp.floattostring(APitchDeg))   
    ser.Str (string(" deg    "))

    
    ser.NewLine
    ser.Str (string(ser#NL, "Gyro Scale: "))
    ser.Str (int.DecPadded(Gscale, 6))

'    ser.str (string(ser#NL, "Gyro Raw"))
'    ser.Str (string(ser#NL, "GX: "))
'    ser.Str (int.DecPadded(gx, 6))
'    ser.Str (string("  GY: "))
'    ser.Str (int.DecPadded(gy, 6))
'    ser.Str (string("  GZ: "))
'    ser.Str (int.DecPadded(gz, 6))

    ser.NewLine
    ser.str (string(ser#NL, "Gyro Calculated"))
    ser.str (string(ser#NL, "Roll: "))
    ser.str (fp.floattostring(GRollDeg))

    ser.str (string(ser#NL, "Pitch "))
    ser.str (fp.floattostring(GPitchDeg))    

    ser.NewLine
    ser.str (string(ser#NL, "Time: "))
    ser.str (fp.floattostring(Timer))
    ser.Str (string(ser#NL, "CNT: "))
    ser.Str (int.DecPadded(cnt, 8))
      
    waitcnt((clkfreq / 25) + cnt)


PUB CalibrateGyro  | samples, axa, aya, aza     ' Take average to create offset and set starting angle

  samples := 500     'How many data samples to create avg from for offset         
  gxa:=gya:=gza:= 0  'Reset values
  axa:=aya:=aza:= 0
  
  'Accumulate Gyro data to create offset avg
  repeat samples
'    imu.readGyro (@gx, @gy, @gz)   
    imu.readGyroCalculated (@gx, @gy, @gz) 
    gxa += gx
    gya += gy
    gza += gz
  gxa := gxa / samples  
  gya := gya / samples  
  gza := gza / samples

  'Get Accel angle to give Gyro starting angle
  repeat 50
    imu.readAccelCalculated (@ax, @ay, @az) 'Get Accelerometer Data
    axa += ax
    aya += ay
    aza += az
  ax := axa / 50
  ay := aya / 50
  az := aza / 50
    
  GRTrack := ff.FMul(PiCalc,(ff.atan2(ff.FFloat(ax), ff.FFloat(az))))  'Set Gyro roll to match accel roll as starting point
  GPTrack := ff.FMul(PiCalc,(ff.atan2(ff.FFloat(ay), ff.FFloat(az))))  'Set Gyro pitch start point
    

PUB Balance(ARoll, APitch, GRoll, Gpitch, TimerG) | SmXa, SmYa, SmZa, Samples, Time1, Time2, Time3, Time4  

imu.Start (SCL_PIN, SDIO_PIN, CS_AG_PIN, CS_M_PIN, INT_AG_PIN, INT_M_PIN)  ' Launch LS9 Driver into new cog (launched through imu OBJ)
imu.SetAccelScale(AccelSens)   ' Set Accel Scale sensitivity
imu.SetGyroScale(GyroSens)     ' Set Gyro Scale sensitivity
CalibrateGyro



  Repeat
           
    'Accel Smoothing
     SmXa:=SmYa:=SmZa:=0  'Reset Smoothing Averages to 0
      Repeat Smoothing    'Run amount of times defind in CON
        imu.readAccelCalculated (@ax, @ay, @az) 'Get Accelerometer Data
        SmXa += ax        'Accumulate for averaging
        SmYa += ay
        SmZa += az
     ax := SmXa / Smoothing      ' Get avgs 
     ay := SmYa / Smoothing   
     az := SmZa / Smoothing
                      
    'Accel to degrees and display  (adjusted -90deg to represent level orientation as 0deg)    
    long[ARoll]  := (ff.FMul(PiCalc,(ff.atan2(ff.FFloat(ax), ff.FFloat(az)))))    ' Calculate and move to global variable 'ARollDeg'
    long[APitch] := (ff.FMul(PiCalc,(ff.atan2(ff.FFloat(ay), ff.FFloat(az)))))    ' Calculate and move to global variable 'APitchDeg'

    'Gyro Calculations
'    imu.readGyro (@gx, @gy, @gz)       
    imu.readGyroCalculated (@gx, @gy, @gz)  'Get Gyro Data in DPS         
    gx -= gxa 'Subtract from calibration offset avgs
    gy -= gya
    gz -= gza                  


    Time1 := cnt 'Record end of cycle
    
      'Determine if timers are pos or neg and perform math (cnt value ranges from -2,147,483,648 to 2,147,483,647)
      if Time1 => 0 and Time2 => 0        'If start time and end time pos
         Time3 := Time1 - Time2
      elseif Time1 > 0 and Time2 < 0    'If start time pos and end time neg
         Time1 -= 2147483647
         Time2 := ((-2147483648 - Time2) * -1)
         Time3 := Time1 + Time2
      elseif Time1 =< 0 and Time2 =< 0    'If start and end time neg
         Time3 := ((Time2 - Time1) * -1)

    Time2 := cnt 'Record start of cycle
         
    Time4 := ff.FDiv(Time3, 80000000)  'Find how much time has passed               ' 0.001185
    long[TimerG] := Time4     'Send to PST Display    
    
    'Adjust Gyro data
'    gx := ff.FMul(ff.FFloat(gx), ff.ffloat(Time4))           'Adjust gyro by time passed 
'    gy := ff.FMul(ff.FFloat(gy), Time4)
'    gz := ff.FMul(ff.FFloat(gz), Time4)                                                     


    
'    long[Groll]  := GRTrack := ff.Fadd(GRTrack, (ff.FMul(ff.FFloat(gx), 0.001)))  '(ff.FAdd(GRoll,(ff.FMul(ff.FFloat(gx), 0.001))))
'    long[Gpitch] := GPTrack := ff.Fadd(GPTrack, (ff.Fmul(ff.FFloat(gy), 0.001)))  '(ff.FAdd(GPitch,(ff.Fmul(ff.FFloat(gy), 0.001))))


 '   long[Groll]  := GRTrack := ff.fadd(GRTrack, (ff.fmul(ff.ffloat(gx), time4)))
 '   long[Gpitch] := GPTrack := ff.fadd(GRTrack, (ff.fmul(ff.ffloat(gy), 0.00000021875)))  

    '(gx * ((1 / Time4) / 17.5))
    ' GRTrack := FF.Fadd(GRTrack, (ff.fdiv(ff.ffloat(gx), Time4))) 
     long[GRoll] := GRTrack := ff.FAdd(GRTrack, ff.fmul(ff.fmul(ff.ffloat(gx), 0.001), Time4))
                                                                     
    time.MSleep (10)

                                                                                          
 {                                                            
    imu OBJ converts gryoraw to gryocalculated by: ((GyroRaw * 30) / (32768 / 500))
                  30= decimal precision x10        500= gyro dps setting
                  ported = (gyroraw * ((1/Time4)/17.5))
  }

  
PUB Clock(PubTime) | Seconds, dT, T       

Seconds := 1                     ' Initialize seconds to 1
dT := clkfreq
T := cnt


  repeat            ' Keep cog alive
    T += dT         ' Add recorded count to number of passed counts in 1s = number of ticks in 1s
    waitcnt(T)      ' Wait number of ticks calculated in 1 second
    Seconds++       ' Increment 1 second
    long[PubTime] := Seconds  'Transfer seconds to global variable



PUB VerifyImu

   if imu.whoAmI <> $683D               ' Verify LSM9DS1 Startup Successful
      ser.Str (string("LSM9DS1 not found - halting!", ser#NL))
      imu.Stop     ' Stop IMU cog
      ser.Stop     ' Stop Serial cog
      Repeat       ' Dead loop

    
DAT  ' LSM9DS1 GYRO/ACCEL DATA
  
  ag_regmap  byte 54
  byte $04, "ACT_THS         ", 0
  byte $05, "ACT_DUR         ", 0
  byte $06, "INT_GEN_CFG_XL  ", 0
  byte $07, "INT_GEN_THS_X_XL", 0
  byte $08, "INT_GEN_THS_Y_XL", 0
  byte $09, "INT_GEN_THS_Z_XL", 0
  byte $0A, "INT_GEN_DUR_XL  ", 0
  byte $0B, "REFERENCE_G     ", 0
  byte $0C, "INT1_CTRL       ", 0
  byte $0D, "INT2_CTRL       ", 0
  byte $0F, "WHO_AM_I_XG     ", 0
  byte $10, "CTRL_REG1_G     ", 0
  byte $11, "CTRL_REG2_G     ", 0
  byte $12, "CTRL_REG3_G     ", 0
  byte $13, "ORIENT_CFG_G    ", 0
  byte $14, "INT_GEN_SRC_G   ", 0
  byte $15, "OUT_TEMP_L      ", 0
  byte $16, "OUT_TEMP_H      ", 0
  byte $17, "STATUS_REG_0    ", 0
  byte $18, "OUT_X_L_G       ", 0
  byte $19, "OUT_X_H_G       ", 0
  byte $1A, "OUT_Y_L_G       ", 0
  byte $1B, "OUT_Y_H_G       ", 0
  byte $1C, "OUT_Z_L_G       ", 0
  byte $1D, "OUT_Z_H_G       ", 0
  byte $1E, "CTRL_REG4       ", 0
  byte $1F, "CTRL_REG5_XL    ", 0
  byte $20, "CTRL_REG6_XL    ", 0
  byte $21, "CTRL_REG7_XL    ", 0
  byte $22, "CTRL_REG8       ", 0
  byte $23, "CTRL_REG9       ", 0
  byte $24, "CTRL_REG10      ", 0       
  byte $26, "INT_GEN_SRC_XL  ", 0
  byte $27, "STATUS_REG_1    ", 0     
  byte $28, "OUT_X_L_XL      ", 0       
  byte $29, "OUT_X_H_XL      ", 0       
  byte $2A, "OUT_Y_L_XL      ", 0       
  byte $2B, "OUT_Y_H_XL      ", 0       
  byte $2C, "OUT_Z_L_XL      ", 0       
  byte $2D, "OUT_Z_H_XL      ", 0       
  byte $2E, "FIFO_CTRL       ", 0        
  byte $2F, "FIFO_SRC        ", 0         
  byte $30, "INT_GEN_CFG_G   ", 0    
  byte $31, "INT_GEN_THS_XH_G", 0 
  byte $32, "INT_GEN_THS_XL_G", 0 
  byte $33, "INT_GEN_THS_YH_G", 0 
  byte $34, "INT_GEN_THS_YL_G", 0 
  byte $35, "INT_GEN_THS_ZH_G", 0
  byte $36, "INT_GEN_THS_ZL_G", 0 
  byte $37, "INT_GEN_DUR_G   ", 0    
  byte $00, "                ", 0

  m_regmap  byte 24
  byte $05, "OFFSET_X_REG_L_M", 0 
  byte $06, "OFFSET_X_REG_H_M", 0 
  byte $07, "OFFSET_Y_REG_L_M", 0 
  byte $08, "OFFSET_Y_REG_H_M", 0 
  byte $09, "OFFSET_Z_REG_L_M", 0 
  byte $0A, "OFFSET_Z_REG_H_M", 0 
  byte $0F, "WHO_AM_I_M      ", 0       
  byte $20, "CTRL_REG1_M     ", 0      
  byte $21, "CTRL_REG2_M     ", 0      
  byte $22, "CTRL_REG3_M     ", 0      
  byte $23, "CTRL_REG4_M     ", 0      
  byte $24, "CTRL_REG5_M     ", 0      
  byte $27, "STATUS_REG_M    ", 0     
  byte $28, "OUT_X_L_M       ", 0        
  byte $29, "OUT_X_H_M       ", 0        
  byte $2A, "OUT_Y_L_M       ", 0        
  byte $2B, "OUT_Y_H_M       ", 0        
  byte $2C, "OUT_Z_L_M       ", 0        
  byte $2D, "OUT_Z_H_M       ", 0        
  byte $30, "INT_CFG_M       ", 0        
  byte $30, "INT_SRC_M       ", 0        
  byte $32, "INT_THS_L_M     ", 0      
  byte $33, "INT_THS_H_M     ", 0      
  byte $00, "                ", 0


DAT  ' SERVO CONTROL DATA & PIN ASSIGNMENTS
'The assembly program below runs on a parallel cog and checks the value of the "position1" and "position2" variables in the
' main RAM (which other cogs can change at any time). It then outputs two servo high pulses (back to back) each corresponding
' to the two position variables (which represent the number of system clock ticks during which each pulse is outputed) and
' sends a 10ms low part of the pulse. It repeats this signal continuously and changes the width of the high pulses as the 
' "position1" and "position2" variables are changed by other cogs.

TwoServos     org                         'Assembles the next command to the first cell (cell 0) in the new cog's RAM                                                                                                                   
Loop          mov       dira,ServoPin1    'Set the direction of the "ServoPin1" to be an output (and all others to be inputs)  
              rdlong    HighTime,p1       'Read the "position1" variable from Main RAM and store it as "HighTime"
              mov       counter,cnt       'Store the current system clock count in the "counter" cell's address 
              mov       outa,AllOn        'Set all pins on this cog high (really only sets ServoPin1 high b/c rest are inputs)               
              add       counter,HighTime  'Add "HighTime" value to "counter" value
              waitcnt   counter,0         'Wait until cnt matches counter (adds 0 to "counter" afterwards)
              mov       outa,#0           'Set all pins on this cog low (really only sets ServoPin1 low b/c rest are inputs)
              
              mov       dira,ServoPin2    'Set the direction of the "ServoPin2" to be an output (and all others to be inputs)  
              rdlong    HighTime,p2       'Read the "position2" variable from Main RAM and store it as "HighTime"
              mov       counter,cnt       'Store the current system clock count in the "counter" cell's address    
              mov       outa,AllOn        'Set all pins on this cog high (really only sets ServoPin2 high b/c rest are inputs)            
              add       counter,HighTime  'Add "HighTime" value to "counter" value
              waitcnt   counter,LowTime   'Wait until "cnt" matches "counter" then add a 10ms delay to "counter" value 
              mov       outa,#0           'Set all pins on this cog low (really only sets ServoPin2 low b/c rest are inputs)
              waitcnt   counter,0         'Wait until cnt matches counter (adds 0 to "counter" afterwards)
              jmp       #Loop             'Jump back up to the cell labled "Loop"                                      
                                                                                                                    
'Constants and Variables:
ServoPin1     long      |<      10 '<------- This sets the pin that outputs the first servo signal (which is sent to the white
                                          ' wire on most servomotors). Here, this "7" indicates Pin 7. Simply change the "7"
                                          ' to another number to specify another pin (0-31).
ServoPin2     long      |<      11 '<------- This sets the pin that outputs the second servo signal (could be 0-31). 
p1            long      0                 'Used to store the address of the "position1" variable in the main Hub RAM
p2            long      0                 'Used to store the address of the "position2" variable in the main Hub RAM
AllOn         long      $FFFFFFFF         'This will be used to set all of the pins high (this number is 32 ones in binary)
LowTime       long      500_000           'This works out to be a 10ms pause time with an 80MHz system clock. If the
                                          ' servo behaves erratically, this value can be changed to 1_600_000 (20ms pause)                                  
counter       res                         'Reserve one long of cog RAM for this "counter" variable                     
HighTime      res                         'Reserve one long of cog RAM for this "HighTime" variable
              fit                         'Makes sure the preceding code fits within cells 0-495 of the cog's RAM